#library "opppRemastered"
#include "zcommon.acs"
#include "defs.acs"
#include "funcs.acs"

#libdefine OPPP_ITEMSPAWN		17879
#libdefine OPPP_ITEMPICKUP		17878
#libdefine OPPP_HIDECS			17876
#libdefine OPPP_FLASHPICKUPCS	17875

str itemTypes[MAXITEMSTYPES] =
{
	"OriginalArmorBonus",
	"OrginalHealthBonus",
	"OriginalStimpack",
	"OriginalMedikit",
	"OriginalSoulsphere",
	"OriginalMegasphere",
	"OriginalBlueArmor",
	"OriginalGreenArmor",
	"OriginalShellBox",
	"OriginalClipBox",
	"OriginalRocketBox",
	"OriginalCellPack",
	"OriginalBerserk",
	"OriginalInfrared",
	"OriginalBackpack",
	"OriginalShell",
	"OriginalRocketAmmo",
	"OriginalClip",
	"OriginalCell",
	"OriginalChaingun",
	"OriginalShotgun",
	"OriginalMiniClip"
};

script 17877 ENTER
{
	delay(1);
	if (!CheckInventory("OriginalClip"))
		GiveInventory("OriginalClip", 50);
	
	int i, j, iterations;
	do
	{

	iterations = 64;
	//int  playerCloseItems[MAXPLAYERS][MAXITEMS];
	playerCloseItemsCant[PlayerNumber()]=0;
	int tmpDist=0.0;
	for (j=0; j < itemSpawned; j++, iterations--)
	{
		if (iterations <= 0)
		{
			delay(1); //suspiro
			iterations = 64;
		}
		if (playerAlreadyPicked(PlayerNumber(), j))
			continue;
		//tmpDist = dist3D(itemsData[j][1], itemsData[j][2], itemsData[j][3], GetActorX(0), GetActorY(0), GetActorZ(0));
		tmpDist = fakeDist3D(itemsData[j][1], itemsData[j][2], itemsData[j][3], GetActorX(0), GetActorY(0), GetActorZ(0));
		if (tmpDist <= 0)
			continue;
		if (tmpDist <= 300.0) //no creo que corra mas de 300 unidades en medio segundo
		{
			playerCloseItems[PlayerNumber()][playerCloseItemsCant[PlayerNumber()]] = j;
			playerCloseItemsCant[PlayerNumber()]++;
		}
	}
	//printBold(s: "cercanos: ", d:playerCloseItemsCant[PlayerNumber()]);
	delay(7); //analizar cada medio segundo
	}while(PlayerInGame(PlayerNumber()));
}

script OPPP_ITEMSPAWN (int itemType)
{
	if (itemSpawned >= MAXITEMS)
		terminate;
	
	int tmpTid = NextTID();
	Thing_ChangeTid(0, tmpTid);
	itemsData[itemSpawned][0] = itemType;
	itemsData[itemSpawned][1] = GetActorX(0);
	itemsData[itemSpawned][2] = GetActorY(0);
	itemsData[itemSpawned][3] = GetActorZ(0);
	itemsData[itemSpawned][4] = tmpTid;
	itemSpawned++;
}

script OPPP_ITEMPICKUP (int itemType, int radiusMax)
{
	if (playerEstudiandoItem[PlayerNumber()])
		terminate;
		
	int tmpLife = GetActorProperty(0, APROP_HEALTH);
	switch (itemType)
	{
		case 2:
		case 3:
			if (tmpLife >= 100) //Ni vale la pena gastarse total no lo puede agarrar
				terminate;
		break;
		case 1:					//Ni vale la pena gastarse total no lo puede agarrar
			if (tmpLife >= 200)
				terminate;
		break;
		
		case 20: //Shotgun pickup
			if (CheckInventory("OriginalShotgun") && ((!CheckInventory("OriginalBackpack") && CheckInventory("OriginalShell") >= 50) || (CheckInventory("OriginalBackpack") && CheckInventory("OriginalShell") >= 100)))
				terminate;
		break;
		
		case 15:
		case 8:
			if ((!CheckInventory("OriginalBackpack") && CheckInventory("OriginalShell") >= 50) || (CheckInventory("OriginalBackpack") && CheckInventory("OriginalShell") >= 100))
				terminate;
		break;
		
		case 19: //Chaingun Pickup
			if (CheckInventory("OriginalChaingun") && ((!CheckInventory("OriginalBackpack") && CheckInventory("OriginalClip") >= 200) || (CheckInventory("OriginalBackpack") && CheckInventory("OriginalClip") >= 400)))
				terminate;
		break;
		case 21:
		case 17:
		case 9:
			if ((!CheckInventory("OriginalBackpack") && CheckInventory("OriginalClip") >= 200) || (CheckInventory("OriginalBackpack") && CheckInventory("OriginalClip") >= 400))
				terminate;
		break;
		
		case 16:
		case 10:
			if ((!CheckInventory("OriginalBackpack") && CheckInventory("OriginalRocketAmmo") >= 50) || (CheckInventory("OriginalBackpack") && CheckInventory("OriginalRocketAmmo") >= 100))
				terminate;
		break;
		
		case 18:
		case 11:
			if ((!CheckInventory("OriginalBackpack") && CheckInventory("OriginalCell") >= 300) || (CheckInventory("OriginalBackpack") && CheckInventory("OriginalCell") >= 600))
				terminate;
		break;
	}
	
	playerEstudiandoItem[PlayerNumber()] = true;
	//Log(s: "Item agarrado: ", d:closestItemToPos(GetActorX(0), GetActorY(0), GetActorZ(0)));
	int itemPicked = closestItemToPos(GetActorX(0), GetActorY(0), GetActorZ(0), intToFixed(radiusMax), itemType);
	if (itemPicked >= 0)
	{
	int i;
	int invisible=0;
	if (!playerAlreadyPicked(PlayerNumber(), itemPicked))
	{
		switch(itemsData[itemPicked][0])
		{
			case 2: //Stimpack
				tmpLife += 10;
				if (tmpLife > 100)
					tmpLife = 100;
				SetActorProperty(0, APROP_HEALTH, tmpLife);
			break;
			case 3: //medkit
				tmpLife += 25;
				if (tmpLife > 100)
					tmpLife = 100;
				SetActorProperty(0, APROP_HEALTH, tmpLife);
			break;
			case 4: //Soulsphere
				tmpLife += 100;
				if (tmpLife > 200)
					tmpLife = 200;
				SetActorProperty(0, APROP_HEALTH, tmpLife);
			break;
			case 8:
				GiveInventory("OriginalShell", 20);
			break;
			case 9:
				GiveInventory("OriginalClip", 50);
			break;
			case 10:
				GiveInventory("OriginalRocketAmmo", 5);
			break;
			case 11:
				GiveInventory("OriginalCell", 100);
			break;
			case 15: //OPPPShell
				GiveInventory("OriginalShell", 4);
			break;
			case 17: //OPPPClip
				GiveInventory("OriginalClip", 10);
			break;
			case 18: //OPPPCell
				GiveInventory("OriginalCell", 20);
			break;
			case 19: //OPPPChaingun
				if (!CheckInventory("OriginalChaingun"))
					GiveInventory("OriginalChaingun", 1);
				else
					GiveInventory("OriginalClip", 10);
			break;
			case 20: //OPPPShotgun
				if (!CheckInventory("OriginalShotgun"))
					GiveInventory("OriginalShotgun", 1);
				else
					GiveInventory("OriginalShell", 4);
			break;
			case 21:  //OPPPMiniClip
				GiveInventory("OriginalClip", 5);
			break;
			default:
				GiveInventory(itemTypes[itemsData[itemPicked][0]], 1);
			break;
		}
		SetHudSize(800, 600, true);
		HudMessage(s: "Pickup!"; HUDMSG_FADEOUT, 13, CR_RED, 5.1, 10.1, 1.0, 0.5, 1.0);	//Emulando el pickup xD
		PlaySound(0, "oppp/pickup");													//Emulando el pickup xD
		ACS_ExecuteAlways(OPPP_FLASHPICKUPCS, 0); 										//Emulando pickup flash
		playerHaveItem[PlayerNumber()][playerItemsPicked[PlayerNumber()]] = itemPicked;
		playerItemsPicked[PlayerNumber()]++;
		ACS_ExecuteAlways(OPPP_HIDECS, 0, itemsData[itemPicked][4], invisible);
	}
	}
	delay(3); //No menos que esto
	playerEstudiandoItem[PlayerNumber()] = false;
}

script OPPP_HIDECS (int itemTid, int invisible) CLIENTSIDE
{
	if (PlayerNumber() != ConsolePlayerNumber())
		terminate;
	if (!invisible)
		SetActorProperty(itemTid, APROP_ALPHA, 0.25);
	else
		SetActorProperty(itemTid, APROP_ALPHA, 0.0);
}

script OPPP_FLASHPICKUPCS (void) CLIENTSIDE
{
	if (PlayerNumber() != ConsolePlayerNumber())
		terminate;
	
	FadeTo(255, 255, 255, 0.2, 0.1);
	Delay(4);
	FadeTo(255, 255, 255, 0.0, 0.1);
}

function bool playerAlreadyPicked(int pn, int itemIndex)
{
	int i;
	for (i=0; i < playerItemsPicked[pn]; i++)
	{
		if (playerHaveItem[pn][i] == itemIndex)
			return true;
	}
	return false;
}

function int closestItemToPos(int xPos, int yPos, int zPos, int maxRadius, int itemType)
{
	int i;
	int closeDist=maxRadius;
	int tmpDist, closestIndex=-1;
	for (i=0; i < playerCloseItemsCant[PlayerNumber()]; i++)
	{
		if (itemType != -1 && itemType != itemsData[playerCloseItems[PlayerNumber()][i]][0]) //No gastarse en elementos diferentes al que se quiere agarrar
			continue;
		
		//tmpDist = dist3D(itemsData[playerCloseItems[PlayerNumber()][i]][1], itemsData[playerCloseItems[PlayerNumber()][i]][2], itemsData[playerCloseItems[PlayerNumber()][i]][3], xPos, yPos,  zPos);
		tmpDist = fakeDist3D(itemsData[playerCloseItems[PlayerNumber()][i]][1], itemsData[playerCloseItems[PlayerNumber()][i]][2], itemsData[playerCloseItems[PlayerNumber()][i]][3], xPos, yPos,  zPos);
		if (tmpDist <= 0)
			continue;
		if (tmpDist < closeDist)
		{
			closeDist = tmpDist;
			closestIndex = playerCloseItems[PlayerNumber()][i];
		}
	}
	return closestIndex;
}